﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApp1.Entities;

namespace WpfApp1
{
    /// <summary>
    /// Логика взаимодействия для AddEditPage.xaml
    /// </summary>
    public partial class AddEditPage : Page
    {
        private User _currentUser = new User();
        public AddEditPage(User SelectedUser)
        {
            InitializeComponent();
            if (SelectedUser != null)
                _currentUser = SelectedUser;
     
            DataContext = _currentUser;
            _currentUser.IsDeleted = false;
        }

        private void BtnSave_Click(object sender, RoutedEventArgs e)
        {
            StringBuilder errors = new StringBuilder();
            if (string.IsNullOrWhiteSpace(_currentUser.Password)) errors.AppendLine("Укажите парольчик!!");
            if (string.IsNullOrWhiteSpace(_currentUser.FirstName)) errors.AppendLine("Укажите Имя");
            if (string.IsNullOrWhiteSpace(_currentUser.MiddleName)) errors.AppendLine("Укажите Фамилию");
            if (string.IsNullOrWhiteSpace(_currentUser.LastName)) errors.AppendLine("Укажите Отчество");
            if (string.IsNullOrWhiteSpace(_currentUser.Login)) errors.AppendLine("Укажите логин");
            if (errors.Length > 0)
            {
                MessageBox.Show(errors.ToString());
            }
            if (_currentUser.ID == 0)
                user7Entities.GetContext().User.Add(_currentUser);
            try
            {
                user7Entities.GetContext().SaveChanges();
                MessageBox.Show("Данные сохранены!");
                Manager.MainFrame.GoBack();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString());
            }
        }
    }
}
